from Widget import Widget
from NoDebug import *

"""
class LabelWidget(Widget):
    " " " One line widget of fixed text
        May become deprecated in favour of TextWidget.
        You cannot write to the last character of a TextWidget (ncurses will complain)
    " " "
    def __init__(self,window,pos,text):
        Widget.__init__(self,window,pos)
        self.text=text
        self.init()

    def init(self):
#        debugmsg('LabelWidget.init(): %dx%d'%(self.rect.wid(),self.rect.hgt()))
        if self.rect.hgt()!=1:
            raise 'assert','LabelWidget is '+str(self.rect.hgt())+'rows high, not 1!'
        self.pad=apply(self.window.pad.subpad,self.rect.hwyx())
        self.draw()

    def draw(self):
#        debugmsg('LabelWidget.draw()')
        self.pad.bkgd(self.window.root.attrmap[0x8F]+255)
        self.pad.addstr(0,0,self.text[:self.rect.wid()-1]) # string is sometimes longer due to ctl-chars...beware!
        self.pad.clrtoeol()
"""

class TextWidget(Widget):
    """
        One line of changable text
    """
    def __init__(self,window,pos,text=None,colour=None):
        Widget.__init__(self,window,pos)
        if text:
            self.text=text
        else:
            self.text='(no text)'
        if colour:
            self.colour=colour
        else:                            # use default
#            self.colour=window.colour['window']
            self.colour=0x1F
        self.init()

    def init(self):
        debugmsg('TextWidget.init(): %dx%d'%(self.rect.wid(),self.rect.hgt()))
        if self.rect.hgt()!=1:
            raise 'assert','TextWidget is %d rows high, not 1!'%(self.rect.hgt())
        self.pad=apply(self.window.pad.subpad,self.rect.hwyx())
        self.draw()

    def draw(self):
#        debugmsg('LabelWidget.draw()')
        self.pad.bkgd(self.window.root.attrmap[self.colour]+255)
        self.pad.addstr(0,0,self.text[:self.rect.wid()-1]) # string is sometimes longer due to ctl-chars...beware!
        self.pad.clrtoeol()

    def set_colour(self,col):
        self.colour=col
        self.draw()

    def set(self,text):
        self.text=text
        self.draw()

