"""
   I suppose if the documentation I write here is good enough, anybody will be
       able to write thier own widgets.
"""

from Rect import *

class Widget:
    """ Widget base class
#        Other optional methods:
#            handle_key(self,key)         # if a widget can have focus and therefore accept keypresses
#            cursor_pos(self)             # returns (x,y)
    """
    def __init__(self,window,pos):
        """ Widget base constructor
            Derived class should will probably only call the base constructor,
                check (and initialise) any extra args. Probably not in that
                order, unfortunately.
            You will probably want to call init() from your constructors.
            A subpad is not created here. That's your job.
        """
        self.window=window
        self.rect=Rect(window.rect,pos)        # position relative to window. subpads do not necessarily have to be this size. (as long as they fit inside it, of course)
        self.window.widgets.append(self)
#        if hasattr(self,'handle_key'):
#            self.window.taborder.append(self) # add self to window's tab list
#            if not self.window.curr_widget:   # first widget?
#                self.window.curr_widget=self  # then make myself current widget

    def init(self):
        """ Initialise Widget
            Called by constructor, *and when widget gets resized*.
            For now, it is expected that init() will call draw() as required.
            Remember things may well break if your widget has a non-positive
                size. You may wish to check for such situations! :)
        """
        raise "assert","%s failed to provide an init() method!"%self

    def draw(self):
        raise "assert","%s failed to provide a draw() method!"%self

    def update(self):
        self.window.update(self.rect)     # refresh self
