#!/usr/bin/env python
""" User interface

    20000305: * Goodness it's been a while since I've done much with this
                code. Just thought I'd point out that a lot of this code
                assumes code page 437. I suppose one day I'll add support
                for more restrictive character sets.
    19990621: * Rewriting for more general (ie. Borland TP6-ish rather than
                TP5.5-ish style windowing)
    19990623: * Hmm, this might actually turn into some useful GUI code.
    19990718: * bold/reverse/underline implemented (as fg^8, swap(fg,bg) and 
                bg^8 respectively.
    19990719: * mIRC-style colours implemented!
    19990720: * the ncurses-end of colour handling now successfully displays
                all 256 colour combinations correctly, selecting high intensity
                colours at the right time, and makgin spaces the right colour.
                This assumes a printable chr(255) and Blink remapped to high-
                intensity background colours.
              * /me wonders why curses.KEY_* constants are sometimes lower
                case.
              * Version of Python, cursesmodule, curses : 
                + mermaid: 1.5.1-7 1.5b1         4.2-3   (key_*)
                + mussel:  1.5.2-4 1.2           4.2-3.2 (KEY_*)
                + starfish:1.5.1   -             ?
    19990721: * Remove window argument from get_key() return value, and from
                various related handlers (because they can just get the same
                from the switchbar)?
    19991113: * Ironed a couple more colour bugs in BufferWidget.
              * Speaking of which, I really should get the scrollback
                happening. At the moment formatted text is being directly
                written to the widget's pad. I think I have to make the pad
                substantially taller. Resizing should be interesting. May just
                have a pad size much less than scrollback lines size...
              * *scream* curses module is missing copywin()!
    19991125: * Decided to lose Widget names, even though the
                window['widgetname'] syntax was kinda cute.
              * While I remember, a tip:
                The window manager (well, Widget, __init__()) determines that
                a Widget is capable of accepting focus by the presence of a
                handle_key() Widget method. If there's a handle_key() then it
                is expected that there is a cursor_pos() too.
              * Started on ButtonWidget
    19991127: * Hmm, I need a drop down box. Or a list box.
              * curses module is also missing curs_set(), but I can live
                without it for now.
    19991128: * TextWidget constructors now can have text and colour args.
              * I really should set some default colours that are not
                so...gaudy.
    19991129: * Hmm, what to do about drawing input & list widgets on a
                non-colour display. Bracketing fields conditionally will
                make the code a little untidy but on the other hand will
                mean better usabilty on many more machines...
    19991130: * Added 4 char indent to (Old)BufferWidget char wrap code.
              * Should probably rename hide() to close() at some stage...
    20000305: * Just thought I'd point out that a lot of this code assumes
                code page 437. I suppose one day I'll add support for more
                restrictive character sets.
              * Thinking about ripping off LeafChat's window positioning (ie.
                positions with a fraction of window width/height component
                (note that this makes it possible to make a square window in
                the centre of the screen, or a window that's always on the
                righthand edge (a la ICQ))).
                Positions would be specified in the form (x,xw,y,yh), so that
                a centred 12x10 window would be (-6,0.5,-5,0.5, 6,0.5,5,0.5)
                and a 10-wide window on the right side (ICQ mode) would be
                (-10,1,0,0, 0,1,0,1). Simple, yes? :)
              * I ought to split class Rect into a class of its own.
    20000403: * Started thinking about splitting initialisation code into a
                separate file.
    20000408: * Stopped thinking about splitting initialisation code into a
                separate file.
              * The globals that pepper this file (stdscr, attrmap) bug me.
                For one, they tend to make splitting this file (eg. class
                Widget, class Window, initialisation code) messy.
    20000524: * Thinking about adding semaphore locks to windows

WOBBLE (1.5b1)
>>> dir(curses)
['ACS_BBSS', 'ACS_BLOCK', 'ACS_BOARD', 'ACS_BSBS', 'ACS_BSSB', 'ACS_BSSS', 'ACS_BTEE', 'ACS_BULLET',
 'ACS_CKBOARD', 'ACS_DARROW', 'ACS_DEGREE', 'ACS_DIAMOND', 'ACS_GEQUAL', 'ACS_HLINE', 'ACS_LANTERN',
 'ACS_LARROW', 'ACS_LEQUAL', 'ACS_LLCORNER', 'ACS_LRCORNER', 'ACS_LTEE', 'ACS_NEQUAL', 'ACS_PI',
 'ACS_PLMINUS', 'ACS_PLUS', 'ACS_RARROW', 'ACS_RTEE', 'ACS_S1', 'ACS_S3', 'ACS_S9', 'ACS_SBBS', 'ACS_SBSB',
 'ACS_SBSS', 'ACS_SSBB', 'ACS_SSBS', 'ACS_SSSB', 'ACS_SSSS', 'ACS_STERLING', 'ACS_TTEE', 'ACS_UARROW',
 'ACS_ULCORNER', 'ACS_URCORNER', 'ACS_VLINE',

 'A_ALTCHARSET', 'A_ATTRIBUTES', 'A_BLINK', 'A_BOLD', 'A_CHARTEXT', 'A_COLOR', 'A_DIM', 'A_HORIZONTAL',
 'A_INVIS', 'A_LEFT', 'A_LOW', 'A_NORMAL', 'A_PROTECT', 'A_REVERSE', 'A_RIGHT', 'A_STANDOUT', 'A_TOP',
 'A_UNDERLINE', 'A_VERTICAL',

 'COLOR_BLACK', 'COLOR_BLUE', 'COLOR_CYAN', 'COLOR_GREEN', 'COLOR_MAGENTA', 'COLOR_PAIR', 'COLOR_RED',
 'COLOR_WHITE', 'COLOR_YELLOW',

 'KEY_A1', 'KEY_A3', 'KEY_B2', 'KEY_BACKSPACE', 'KEY_BEG', 'KEY_BREAK', 'KEY_BTAB', 'KEY_C1', 'KEY_C3',
 'KEY_CANCEL', 'KEY_CATAB', 'KEY_CLEAR', 'KEY_CLOSE', 'KEY_COMMAND', 'KEY_COPY', 'KEY_CREATE', 'KEY_CTAB',
 'KEY_DC', 'KEY_DL', 'KEY_DOWN', 'KEY_EIC', 'KEY_END', 'KEY_ENTER', 'KEY_EOL', 'KEY_EOS', 'KEY_EXIT',
 'KEY_F0', 'KEY_F1', 'KEY_F10', 'KEY_F11', 'KEY_F12', 'KEY_F13', 'KEY_F14', 'KEY_F15', 'KEY_F16', 'KEY_F17',
 'KEY_F18', 'KEY_F19', 'KEY_F2', 'KEY_F20', 'KEY_F21', 'KEY_F22', 'KEY_F23', 'KEY_F24', 'KEY_F25', 'KEY_F26',
 'KEY_F27', 'KEY_F28', 'KEY_F29', 'KEY_F3', 'KEY_F30', 'KEY_F31', 'KEY_F32', 'KEY_F33', 'KEY_F34', 'KEY_F35',
 'KEY_F36', 'KEY_F37', 'KEY_F38', 'KEY_F39', 'KEY_F4', 'KEY_F40', 'KEY_F41', 'KEY_F42', 'KEY_F43', 'KEY_F44',
 'KEY_F45', 'KEY_F46', 'KEY_F47', 'KEY_F48', 'KEY_F49', 'KEY_F5', 'KEY_F50', 'KEY_F51', 'KEY_F52', 'KEY_F53',
 'KEY_F54', 'KEY_F55', 'KEY_F56', 'KEY_F57', 'KEY_F58', 'KEY_F59', 'KEY_F6', 'KEY_F60', 'KEY_F61', 'KEY_F62',
 'KEY_F63', 'KEY_F7', 'KEY_F8', 'KEY_F9', 'KEY_FIND', 'KEY_HELP', 'KEY_HOME', 'KEY_IC', 'KEY_IL', 'KEY_LEFT',
 'KEY_LL', 'KEY_MARK', 'KEY_MAX', 'KEY_MESSAGE', 'KEY_MIN', 'KEY_MOUSE', 'KEY_MOVE', 'KEY_NEXT', 'KEY_NPAGE',
 'KEY_OPEN', 'KEY_OPTIONS', 'KEY_PPAGE', 'KEY_PREVIOUS', 'KEY_PRINT', 'KEY_REDO', 'KEY_REFERENCE',
 'KEY_REFRESH', 'KEY_REPLACE', 'KEY_RESET', 'KEY_RESIZE', 'KEY_RESTART', 'KEY_RESUME', 'KEY_RIGHT',
 'KEY_SAVE', 'KEY_SBEG', 'KEY_SCANCEL', 'KEY_SCOMMAND', 'KEY_SCOPY', 'KEY_SCREATE', 'KEY_SDC', 'KEY_SDL',
 'KEY_SELECT', 'KEY_SEND', 'KEY_SEOL', 'KEY_SEXIT', 'KEY_SF', 'KEY_SFIND', 'KEY_SHELP', 'KEY_SHOME',
 'KEY_SIC', 'KEY_SLEFT', 'KEY_SMESSAGE', 'KEY_SMOVE', 'KEY_SNEXT', 'KEY_SOPTIONS', 'KEY_SPREVIOUS',
 'KEY_SPRINT', 'KEY_SR', 'KEY_SREDO', 'KEY_SREPLACE', 'KEY_SRESET', 'KEY_SRIGHT', 'KEY_SRSUME', 'KEY_SSAVE',
 'KEY_SSUSPEND', 'KEY_STAB', 'KEY_SUNDO', 'KEY_SUSPEND', 'KEY_UNDO', 'KEY_UP',

 'PAIR_NUMBER',

 'WA_ALTCHARSET', 'WA_ATTRIBUTES', 'WA_BLINK', 'WA_BOLD', 'WA_DIM', 'WA_HORIZONTAL',
 'WA_INVIS', 'WA_LEFT', 'WA_LOW', 'WA_NORMAL', 'WA_PROTECT', 'WA_REVERSE', 'WA_RIGHT', 'WA_STANDOUT',
 'WA_TOP', 'WA_UNDERLINE', 'WA_VERTICAL',

 '__doc__', '__file__', '__name__', '__version__',
 'baudrate', 'beep', 'can_change_color', 'cbreak', 'color_content', 'curs_set', 'def_prog_mode',
 'def_shell_mode', 'delay_output', 'doupdate', 'echo', 'endwin', 'erasechar', 'error', 'filter', 'flash',
 'flushinp', 'getsyx', 'getwin', 'halfdelay', 'has_colors', 'has_ic', 'has_il', 'has_key', 'init_color',
 'init_pair', 'initscr', 'intrflush', 'isendwin', 'keyname', 'killchar', 'longname', 'meta', 'newpad',
 'newwin', 'nl', 'nocbreak', 'noecho', 'nonl', 'noqiflush', 'noraw', 'pair_content', 'putp', 'qiflush',
 'raw', 'reset_prog_mode', 'reset_shell_mode', 'setsyx', 'start_color', 'termattrs', 'termname', 'unctrl',
 'ungetch', 'use_env', 'version']

MUSSEL (1.2):
>>> dir(curses)
['A_ALTCHARSET', 'A_BLINK', 'A_BOLD', 'A_DIM', 'A_NORMAL', 'A_REVERSE', 'A_STANDOUT', 'A_UNDERLINE',

 'KEY_A1', 'KEY_A3', 'KEY_B2', 'KEY_BACKSPACE', 'KEY_BEG', 'KEY_BREAK', 'KEY_BTAB', 'KEY_C1', 'KEY_C3',
 'KEY_CANCEL', 'KEY_CATAB', 'KEY_CLEAR', 'KEY_CLOSE', 'KEY_COMMAND', 'KEY_COPY', 'KEY_CREATE', 'KEY_CTAB',
 'KEY_DC', 'KEY_DL', 'KEY_DOWN', 'KEY_EIC', 'KEY_END', 'KEY_ENTER', 'KEY_EOL', 'KEY_EOS', 'KEY_EXIT',
 'KEY_F0', 'KEY_F1', 'KEY_F10', 'KEY_F11', 'KEY_F12', 'KEY_F13', 'KEY_F14', 'KEY_F15', 'KEY_F16', 'KEY_F17',
 'KEY_F18', 'KEY_F19', 'KEY_F2', 'KEY_F20', 'KEY_F21', 'KEY_F22', 'KEY_F23', 'KEY_F24', 'KEY_F25', 'KEY_F26',
 'KEY_F27', 'KEY_F28', 'KEY_F29', 'KEY_F3', 'KEY_F30', 'KEY_F31', 'KEY_F32', 'KEY_F33', 'KEY_F34', 'KEY_F35',
 'KEY_F36', 'KEY_F37', 'KEY_F38', 'KEY_F39', 'KEY_F4', 'KEY_F40', 'KEY_F41', 'KEY_F42', 'KEY_F43', 'KEY_F44',
 'KEY_F45', 'KEY_F46', 'KEY_F47', 'KEY_F48', 'KEY_F49', 'KEY_F5', 'KEY_F50', 'KEY_F51', 'KEY_F52', 'KEY_F53',
 'KEY_F54', 'KEY_F55', 'KEY_F56', 'KEY_F57', 'KEY_F58', 'KEY_F59', 'KEY_F6', 'KEY_F60', 'KEY_F61', 'KEY_F62',
 'KEY_F63', 'KEY_F7', 'KEY_F8', 'KEY_F9', 'KEY_FIND', 'KEY_HELP', 'KEY_HOME', 'KEY_IC', 'KEY_IL', 'KEY_LEFT',
 'KEY_LL', 'KEY_MARK', 'KEY_MAX', 'KEY_MESSAGE', 'KEY_MIN', 'KEY_MOUSE', 'KEY_MOVE', 'KEY_NEXT', 'KEY_NPAGE',
 'KEY_OPEN', 'KEY_OPTIONS', 'KEY_PPAGE', 'KEY_PREVIOUS', 'KEY_PRINT', 'KEY_REDO', 'KEY_REFERENCE',
 'KEY_REFRESH', 'KEY_REPLACE', 'KEY_RESET', 'KEY_RESIZE', 'KEY_RESTART', 'KEY_RESUME', 'KEY_RIGHT',
 'KEY_SAVE', 'KEY_SBEG', 'KEY_SCANCEL', 'KEY_SCOMMAND', 'KEY_SCOPY', 'KEY_SCREATE', 'KEY_SDC', 'KEY_SDL',
 'KEY_SELECT', 'KEY_SEND', 'KEY_SEOL', 'KEY_SEXIT', 'KEY_SF', 'KEY_SFIND', 'KEY_SHELP', 'KEY_SHOME',
 'KEY_SIC', 'KEY_SLEFT', 'KEY_SMESSAGE', 'KEY_SMOVE', 'KEY_SNEXT', 'KEY_SOPTIONS', 'KEY_SPREVIOUS',
 'KEY_SPRINT', 'KEY_SR', 'KEY_SREDO', 'KEY_SREPLACE', 'KEY_SRESET', 'KEY_SRIGHT', 'KEY_SRSUME', 'KEY_SSAVE',
 'KEY_SSUSPEND', 'KEY_STAB', 'KEY_SUNDO', 'KEY_SUSPEND', 'KEY_UNDO', 'KEY_UP',

 '__doc__', '__file__', '__name__', '__version__',
             'beep',                     'cbreak',
                                   'doupdate', 'echo', 'endwin',              'error',           'flash',
 'flushinp',
              'initscr', 'intrflush', 'isendwin', 'keyname', 'meta', 'newwin', 'nl', 'nocbreak', 'noecho', 'nonl', 'noraw', 'raw', 'ungetch', 'version']
>>>

WOBBLE
>>> dir(stdscr)
['addch', 'addnstr', 'addstr', 'attr_off', 'attr_on', 'attr_set', 'attroff', 'attron', 'attrset', 'bkgd', 
 'bkgdset', 'border', 'box', 'clear', 'clearok', 'clrtobot', 'clrtoeol', 'cursyncup', 'delch', 'deleteln', 
 'derwin', 'echochar', 'erase', 'getbegyx', 'getbkgd', 'getch', 'getkey', 'getmaxyx', 'getparyx', 'getstr', 
 'getyx', 'hline', 'idcok', 'idlok', 'immedok', 'inch', 'insch', 'insdelln', 'insertln', 'insnstr', 'insstr', 
 'instr', 'is_linetouched', 'is_wintouched', 'keypad', 'leaveok', 'move', 'mvderwin', 'mvwin', 'nodelay', 
 'notimeout', 'noutrefresh', 'putwin', 'redrawln', 'redrawwin', 'refresh', 'resize', 'scroll', 'scrollok', 
 'setscrreg', 'standend', 'standout', 'subpad', 'subwin', 'syncdown', 'syncok', 'syncup', 'touchline', 
 'touchwin', 'untouchwin', 'vline']

Hmm, possible bug with bkgd(): tends to frustrate my disable-flash-and-enable-16-colour-background hack
by not drawing 'flashing' (or rather, colours 8-15) spaces chars. Any other printable char is fine though...

Reminder to self:
bkgd() sets the colour and fills the blanks (and non-blanks?)
bkgdset() just sets the colour

Bug:
Traceback (innermost last):
  File "ui.py", line 387, in ?
    init(test2)
  File "ui.py", line 359, in init
    main()
  File "ui.py", line 381, in test2
    win=Window(Rect(2,2,20,20))
    self.window.border()
SystemError: old style getargs format uses new features

   Because of IRC's scandanavian origin, the characters {}| are considered to be the lower case
   equivalents of the characters []\, respectively. This is a critical issue when determining the
   equivalence of two nicknames.

>>> re.split('(1|2|3|69)','3xxxx1xxxx2xxx21yyy69(4)\\z6zz')
['', '3', 'xxxx', '1', 'xxxx', '2', 'xxx', '2', '', '1', 'yyy', '69', '(4)\\z6zz']
/exec echo('.IAL','hello 1world')

>>> re.split('(X[0-9]{1,2},[0-9]{1,2}X?)','xxxX11,1Xyy')
['xxx', 'X11,1X', 'yy']
>>> re.split('(X[0-9]{1,2},[0-9]{1,2}X?)','xxxX11,Xyy')
['xxxX11,Xyy']
>>> re.split('(X[0-9]{1,2}(?:,[0-9]{1,2})?X?)','xxxX11,111Xyy')
['xxx', 'X11,11', '1Xyy']

\003(?:[0-9]{1,2}(?:,[0-9]{1,2})?)?

blabla ^C5,12to be colored text and background^C blabla
blabla ^C5to be colored text^C blabla
blabla ^C3to be colored text ^C5,2other colored text and also background^C blabla
blabla ^C3,5to be colored text and background ^C8other colored text but SAME background^C blabla
blabla ^C3,5to be colored text and background ^C8,7other colored text and other background^C blabla

0 white                                   15 white       0 black
1 black                                    0 black       1 blue
2 blue     (navy)                          1 blue        2 green
3 green                                    2 green       3 cyan
4 red                                      4 red         4 red
5 brown    (maroon)                        6 brown       5 magenta
6 purple                                   5 magenta     6 brown
7 orange   (olive)                        12 ?l.red      7 l.grey
8 yellow                                  14 yellow      8 d.grey
9 lt.green (lime)                         10 l.green     9 l.blue
10 teal    (a kinda green/blue cyan)       3 cyan       10 l.green
11 lt.cyan (cyan ?) (aqua)                11 l.cyan     11 l.cyan
12 lt.blue (royal)                         9 l.blue     12 l.red
13 pink    (light purple) (fuchsia)       13 ?l.magenta 13 l.magenta
14 grey                                    8 d.grey     14 yellow
15 lt.grey (silver)                        7 l.grey     15 white

ANSI sequences:
\033\[(?:[0-9]*(?:;[0-9]*)?)?m

Implemented:           
Implemented: none
Not yet implemented:   0,1,4?,5?,7,21,22,24,25,27,38,39,49,30-37,40-47
Not to be implemented: 2?,10,11,12

From /usr/doc/kbd/console.docs
Character Rendition Sequences
- -----------------------------
Each parameter is actioned in order.  You cannot get bright backgrounds
(rather, I can't).  {-- On SVR4, attribute code 6 is used for bright
background, if I remember correctly --}

0       default (intensity normal, underline off, blink off, normal video,
        default colours (which start as white on black))
1       intensity bold
2       intensity dim
4       underline on
5       blink on
7       reverse video
10      restore translate table, turn off display of control chars, don't
        set the "top" bit of glyphs displayed
11      disable the translate table, display control chars as glyphs, don't
        set the "top" bit of glyphs displayed
12      disable the translate table, display control chars as glyphs,
        set the "top" bit of glyphs displayed
21 22   intensity normal
24      underline off
25      blink off
27      normal video
38      underline on, set foreground colour to default
39      underline off, set foreground colour to default
49      set background colour to default
30-37   set foreground colour (0-black, 1-red, 2-green, 3-brown, 4-blue,
        5-magenta, 6-cyan, 7-white)
40-47   set background colour

0407193133
"""

from Rect import *
import curses
#import cfg
import string
import re
import sys
import select

###############################################################################

###############################################################################

class Widget:
    """
    Widget base class.
    Other optional methods:
    handle_key(self,key)                 # if a widget can have focus and therefore accept keypresses
    cursor_pos(self)                     # returns (x,y)
    """
    def __init__(self,window,pos):
        self.window=window
        self.pos=window.rect(pos)                     # position relative to window. subpads do not necessarily have to be this size. (as long as they fit inside it, of course)
        if hasattr(self,'handle_key'):
            self.window.taborder.append(self) # add self to window's tab list
            if not self.window.curr_widget: # first widget?
                self.window.curr_widget=self # then make myself current widget

    def update(self):
        self.window.update(self.pos)      # refresh self

###############################################################################

class LabelWidget(Widget):
    """
    One line of fixed text
    May become deprecated.
    """
    def __init__(self,window,pos,text):
        if pos.hgt()!=1:
            raise 'assert','LabelWidget is '+str(pos.hgt())+'rows high, not 1!'
        Widget.__init__(self,window,pos)

        self.pad=apply(window.pad.subpad,self.pos.hwyx())
        self.pad.bkgd(attrmap[0x8F]+ord(''))
        self.pad.addstr(0,0,text[:self.pos.wid()]) # the minus 5 is a temporary hack...string are sometimes longer due to ctl-chars
        self.pad.clrtoeol()
#        self.set('Text goes here')

class TextWidget(Widget):
    """
    One line of changable text
    """
    def __init__(self,window,pos,text=None,colour=None):
        Widget.__init__(self,window,pos)
        if self.pos.hgt()!=1:
            raise 'assert','TextWidget is %dx%d chars, which is not 1 row high!'%(pos.wid(),pos.hgt())

        self.pad=apply(window.pad.subpad,self.pos.hwyx())

        if colour:
            self.set_colour(colour)
        else:
            self.set_colour(window.bgcol)
        if text:
            self.set(text)

    def set_colour(self,col):
        global attrmap

        self.colour=col
        self.pad.bkgd(attrmap[self.colour]+ord(''))

    def set(self,text):
        self.text=text
        self.pad.addstr(0,0,text[:self.pos.wid()-1]) # the minus 1 is because you can't write to the last char of a pad
        self.pad.clrtoeol()
        self.update()

###############################################################################

class ButtonWidget(Widget):
    """
    Try not to make your buttons too narrow (at least 4 chars wide is fine).
    """
    def __init__(self,window,pos,label):
        global attrmap

        Widget.__init__(self,window,pos)

        self.pad=apply(window.pad.subpad,pos.hwyx())
        self.pad.bkgd(attrmap[0x17]+ord(''))
        maxlen=self.pos.wid()-4
        self.pad.addstr(0,1,'['+string.center(label[:maxlen],maxlen)+']')

    def handle_key(self,key):
        if key==32 or key==ord('\r'):
            self.handle_press()

    def cursor_pos(self):
        return (0,0)

###############################################################################

class ListWidget(Widget):
    """
    Please keep Lists at least 3 chars wide...
    """
    def __init__(self,window,pos,list=None):
        global attrmap

        Widget.__init__(self,window,pos)

        self.pad=apply(window.pad.subpad,pos.add(Rect(0,0,-1,0)).hwyx())
        self.set_colour(0x1E,0xB1)
        self.sbpad=apply(window.pad.subpad,Rect(pos.x2(),pos.y1(),pos.x2(),pos.y2()).hwyx())
        self.sbpad.bkgd(attrmap[0x2F]+ord('|'))
        if list:
            self.items=list
        else:
            self.items=[]
        self.y_scroll=0
        self.y_pos=0
        self.redraw()

    def set_colour(self,col,hcol):
        self.colour=col
        self.hcolour=hcol
        self.pad.bkgd(attrmap[self.colour]+255)

    def set_list(self,list,index=0):
        self.items=list
        self.set_index(index)

    def set_index(self,index):
        self.y_pos=index
        whgt=self.pos.hgt()
        if self.y_pos>whgt-1-whgt/3:
            self.y_scroll=self.y_pos-(whgt-1)+whgt/3
        else:
            self.y_scroll=0
        self.redraw()

    def current_item(self):
        return self.items[self.y_pos]

    def current_index(self):
        return self.y_pos

    def get_items(self):
        return self.items

    def handle_key(self,key):
        old_pos=self.y_pos
        whgt=self.pos.hgt()
        if key==curses.KEY_UP:
            if self.y_pos>0:
                self.y_pos=self.y_pos-1
            if self.y_scroll>0 and self.y_scroll>self.y_pos-whgt/3:
                self.y_scroll=self.y_scroll-1
        elif key==curses.KEY_DOWN:
            if self.y_pos<len(self.items)-1:
                self.y_pos=self.y_pos+1
            if self.y_scroll<len(self.items)-whgt and self.y_scroll<self.y_pos+whgt/3-whgt+1:
                self.y_scroll=self.y_scroll+1

        if self.y_pos!=old_pos:
            # change me!
            self.redraw()
            self.handle_update()

    def cursor_pos(self):
        return (0,self.y_pos-self.y_scroll)

    def redraw(self):
        global attrmap

        try:
         hgt=min(len(self.items),self.pos.hgt())
         for y in range(0,hgt):
             self.pad.addstr(y,0,' '+str(self.items[self.y_scroll+y])[:self.pos.wid()-3]+' ')
             self.pad.clrtoeol()
         for y in range(hgt,self.pos.hgt()):
#             self.pad.addstr(y,0,'--')
             self.pad.move(y,0)
             self.pad.clrtoeol()
#         self.pad.addstr(self.y_pos-self.y_scroll,0,'>>s='+str(self.y_scroll)+' p='+str(self.y_pos)+' hgt='+str(hgt)+' '+str(self.items[self.y_scroll+self.y_pos])[:self.pos.wid()-2],attrmap[self.hcolour])
         self.pad.bkgdset(attrmap[self.hcolour]+255)
         self.pad.addstr(self.y_pos-self.y_scroll,0,'>'+string.ljust(str(self.items[self.y_pos])[:self.pos.wid()-3],self.pos.wid()-3)+'<')
#         self.pad.clrtoeol()
         self.pad.bkgdset(attrmap[self.colour]+255)
        except curses.error,e:
         raise 'Oops','len=%d hgt=%d pos=%d scroll=%d' % (len(self.items),self.pos.hgt(),self.y_pos,self.y_scroll)
        self.fresh()

###############################################################################

class OldBufferWidget(Widget):
    """
    This is your typical scrollable static text buffer (with IRC formatting)
    see fmtecho() for more
    """
    format_re=re.compile('(\002|\037|\026|\003(?:[0-9]{1,2}(?:,[0-9]{1,2})?)?)')  # ^B, ^_, ^V, ^C
    colour_map=(15,0,1,10,12,4,5,6,14,2,3,11,9,13,8,7) # resemble default mIRC-colours
#    colour_map=(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15)

    def __init__(self,window,pos):
        Widget.__init__(self,window,pos)

        self.pad=apply(window.pad.subpad,pos.add(Rect(0,0,-1,0)).hwyx())
#        self.pad.bkgd(attrmap[self.colour]+255)
        self.set_colour(0xB1)
        self.pad.bkgd(attrmap[self.colour]+ord(' ')*0+255)
#        self.pad.bkgdset(attrmap[0x47]+ord('?')) # does nothing?
        self.pad.scrollok(1)
        self.pad.move(self.pos.hgt()-1,0)

        self.sbpad=apply(window.pad.subpad,Rect(pos.x2(),pos.y1(),pos.x2(),pos.y2()).hwyx())
        self.sbpad.bkgd(attrmap[0x2E]+ord('|'))

        self.buff=[]
        self.scroll=0                    # number lines up from bottom 

    def set_colour(self,col):
        self.colour=col
        self.pad.bkgd(attrmap[self.colour]+ord(' ')*0+255)

    def fmtecho(self,line):
        """ Output a line of stuff.

        This can be quite slow if there are lots of colours in the text

        To do:
            add scroll-bar handling (should probably implement scrolling first, though ;-)
            add ANSI colour parsing
            add proper word wrap
            Reformat control chars (or persuade ncurses to not caret-ify them)
        """
        global attrmap

        colour=self.colour
        x=0                              # xpos of last char on line, before wrap
        wrapwid=self.pos.wid()-2         # -1 for scrollbar, -1 coz you can't write to last position in a pad
        self.pad.bkgdset(attrmap[colour]+255)  # this is required (blanks to eol before \n)
        self.pad.addstr('\n',attrmap[colour])
        self.pad.bkgdset(attrmap[0x07]+255)  # this is required (colour is the allegedly unchangable COLOR_PAIR(0), char is the blanks inside text)
#        self.pad.bkgdset(attrmap[colour]&~curses.A_BLINK)  # this is required (colour is the allegedly unchangable COLOR_PAIR(0), char is the blanks inside text)
                                         # It enables non-bright foregrounds when bright backgrounds (BLINK) are used. Don't ask.
#        debugmsg('fmtecho(\''+line+'\')')
        line=BufferWidget.format_re.split(line)  # split line into alternating text and formatting sequences
        while 1:
            s=line[0]
#            debugmsg('    \''+s+'\' x='+str(x)+' len='+str(len(s)))
            x=x+len(s)
            while x>=wrapwid:            # will this extend past end of line?
#                self.pad.addstr('x='+str(x)+' wid='+str(self.pos.wid()))
#                debugmsg('        wrap')
                self.pad.addstr(s[:wrapwid-x],attrmap[colour])  # note that wrapwid-x is negative
                self.pad.clrtoeol()
                self.pad.bkgdset(attrmap[colour]+255)  # this is required (blanks to eol before \n)
                self.pad.addstr('\n    ',attrmap[colour])
                self.pad.bkgdset(attrmap[0x07]+255)  # this is required (colour is the allegedly unchangable COLOR_PAIR(0), char is the blanks inside text)
                s=s[self.pos.wid()-2-x:]
                x=x-(self.pos.wid()-2)+4
#            debugmsg('        no (more) wrap')
            self.pad.addstr(s,attrmap[colour])
            del line[0]
            if not line:
                break
            code=line[0]
            if code=='\002':             # ^B
                colour=colour^0x08
            elif code=='\037':           # ^_
                colour=colour^0x80
            elif code=='\026':           # ^V
                colour=(colour>>4)+((colour&15)<<4)
            elif code[0]=='\003':        # ^C
                code=string.split(code[1:],',')
                if not code[0]:          # just a ^C?
                    colour=self.colour
                else:
#                    colour=(colour&0xF0)+(string.atoi(code[0])&0x0F)
                    colour=(colour&0xF0)+self.colour_map[string.atoi(code[0])&0x0F]
                    if len(code)>1:
#                        colour=(colour&0x0F)+(string.atoi(code[1])&0x0F)*0x10
                        colour=(colour&0x0F)+self.colour_map[string.atoi(code[1])&0x0F]*0x10
            elif code[0]=='\033':        # CSI sequences.
               pass                      # ANSI sequences to be implemented later
            del line[0]
        self.pad.bkgdset(attrmap[self.colour]+ord('=')*0+255) # colour and char of space to eol (until \n is output)
        self.pad.clrtoeol()

    def echo(self,line):
        self.buff.append(line) 
#        if len(self.buff)>=200:          # prevent buffer from growing unmanagably large
#            del self.buff[0]

        if not self.scroll:
            self.fmtecho(line)
        self.fresh()

###############################################################################

class NewBufferWidget(Widget):
    """
    This is your typical scrollable static text buffer (with IRC formatting)
    fmtecho() does most of the work
    """
    format_re=re.compile('(\002|\037|\026|\003(?:[0-9]{1,2}(?:,[0-9]{1,2})?)?)')  # ^B, ^_, ^V, ^C
    scroll_len=1000                         # number of formatted lines to store
    buff_len=1000                            # number of unformatted lines to store
                                            # (an unformatted line could require multiple formatted lines, depending on widget and line width)
    def __init__(self,window,pos):
        Widget.__init__(self,window,pos)

        self.buf_pos=pos.add(Rect(0,0,-1,0)) # lose a column on the right for the scroll bar.
        self.buf_pad=curses.newpad(BufferWidget.scroll_len,pos.wid()-1)
        self.set_colour(0xB1)
        self.buf_pad.scrollok(1)
        self.buf_pad.move(BufferWidget.scroll_len-1,0)

        self.sbpad=apply(window.pad.subpad,Rect(pos.x2(),pos.y1(),pos.x2(),pos.y2()).hwyx())
        self.sbpad.bkgd(attrmap[0x2F]+ord('+'))

        self.buff=[]
        self.scroll=0                    # number lines up from bottom 

    def set_colour(self,col):
        self.colour=col
        self.buf_pad.bkgd(attrmap[self.colour]+ord(' ')*0+255)

    def fmtecho(self,line):
        """ Output a line of stuff.

        This can be quite slow if there are lots of colours in the text

        To do:
            add scroll-bar handling (should probably implement scrolling first, though ;-)
            add ANSI colour parsing
            add proper word wrap
            Reformat control chars (or persuade ncurses to not caret-ify them)
        """
        global attrmap

        colour=self.colour
        x=0                              # xpos of last char on line, before wrap
        wrapwid=self.pos.wid()-2         # -1 for scrollbar, -1 coz you can't write to last column in a pad
        self.buf_pad.bkgdset(attrmap[colour]+255)  # this is required (blanks to eol before \n)
        self.buf_pad.addstr('\n',attrmap[colour])
        self.buf_pad.bkgdset(attrmap[0x07]+255)  # this is required (colour is the allegedly unchangable COLOR_PAIR(0), char is the blanks inside text)
#        self.buf_pad.bkgdset(attrmap[colour]&~curses.A_BLINK)  # this is required (colour is the allegedly unchangable COLOR_PAIR(0), char is the blanks inside text)
                                         # It enables non-bright foregrounds when bright backgrounds (BLINK) are used. Don't ask.
#        debugmsg('fmtecho(\''+line+'\')')
        line=BufferWidget.format_re.split(line)  # split line into alternating text and formatting sequences
        while 1:
            s=line[0]
#            debugmsg('    \''+s+'\' x='+str(x)+' len='+str(len(s)))
            x=x+len(s)
            while x>=wrapwid:            # will this extend past end of line?
#                self.buf_pad.addstr('x='+str(x)+' wid='+str(self.pos.wid()))
#                debugmsg('        wrap')
                self.buf_pad.addstr(s[:wrapwid-x],attrmap[colour])  # note that wrapwid-x is negative
                self.buf_pad.clrtoeol()
                self.buf_pad.bkgdset(attrmap[colour]+255)  # this is required (blanks to eol before \n)
                self.buf_pad.addstr('\n',attrmap[colour])
                self.buf_pad.bkgdset(attrmap[0x07]+255)  # this is required (colour is the allegedly unchangable COLOR_PAIR(0), char is the blanks inside text)
                s=s[self.pos.wid()-2-x:]
                x=x-(self.pos.wid()-2)
#            debugmsg('        no (more) wrap')
            self.buf_pad.addstr(s,attrmap[colour])
            del line[0]
            if not line:
                break
            code=line[0]
            if code=='\002':             # ^B
                colour=colour^0x08
            elif code=='\037':           # ^_
                colour=colour^0x80
            elif code=='\026':           # ^V
                colour=(colour>>4)+((colour&15)<<4)
            elif code[0]=='\003':        # ^C
                code=string.split(code[1:],',')
                if not code[0]:          # just a ^C?
                    colour=self.colour
                else:
                    colour=(colour&0xF0)+(string.atoi(code[0])&0x0F)
                    if len(code)>1:
                        colour=(colour&0x0F)+(string.atoi(code[1])&0x0F)*0x10
            elif code[0]=='\033':        # CSI sequences.
               pass                      # ANSI sequences to be implemented later
            del line[0]
        self.buf_pad.bkgdset(attrmap[self.colour]+ord('=')*0+255) # colour and char of space to eol (until \n is output)
        if not self.scroll:
            print (BufferWidget.scroll_len-self.pos.hgt()-2,0)+self.buf_pos.hwyx()
            apply(self.buf_pad.noutrefresh,tuple((BufferWidget.scroll_len-self.pos.hgt()-2,0)+self.buf_pos.hwyx()))
        self.buf_pad.clrtoeol()

    def echo(self,line):
        self.buff.append(line) 
#        if len(self.buff)>=BufferWidget.buff_len:          # prevent buffer from growing unmanagably large
#            del self.buff[0]

        self.fmtecho(line)
        self.fresh()

BufferWidget=OldBufferWidget

###############################################################################

class InputWidget(Widget):
    """
    One line of arbitrary input
    Literal control chars are automatically converted.

    The keypress_handler will go away later, to be replaced by a hierarchy of
    InputWidget classes. *goes mad with classes*
    """

    format_re=re.compile('([\001-\037])') # null bytes may or may not be a problem.

    def __init__(self,window,pos,cb,keypress_handler):
        if pos.hgt()!=1:
            raise 'assert','InputWidget is not 1 row high'
        Widget.__init__(self,window,pos)

        self.pad=apply(window.pad.subpad,pos.hwyx())
        self.pad.bkgd(attrmap[0x1E]+ord('')) # use bkgdset() instead?
#        self.pad.nodelay(1)
#        self.set('Text goes here')
        self.text=''
        self.xpos=0                      # current char=text[xscroll+xpos]
        self.xscroll=0                   # first visible character=text[xscroll]
        self.wid=self.pos.x2()-self.pos.x1()+1
        self.window.input=self           # required?
        self.history=[]                  # history[0]=most recent entry
        self.histindex=-1                # -1=editing line not in history
        self.callback=cb                 # function to call with results
        self.handler=keypress_handler

    def set(self,text):
        self.text=text
        self.xpos=len(text)
        if self.xpos>=self.wid:
            self.xscroll=self.xpos-(self.wid-1)
            self.xpos=self.xpos-self.xscroll
        else:
            self.xscroll=0
        self.redraw()

    def handle_key(self,key):
        self.handler(self,key)

    def handle_key_command(self,key):
        if key==curses.KEY_LEFT:
            self.left()
        elif key==curses.KEY_RIGHT:
            self.right()
        elif key==curses.KEY_HOME:
            self.home()
        elif key==curses.KEY_END:
            self.end()
        elif key==ord('\r'):             # enter
            self.callback(self.text)
            self.enter()
        elif key==curses.KEY_BACKSPACE:
            self.backspace()
        elif key==curses.KEY_UP:
            self.prev()
        elif key==curses.KEY_DOWN:
            self.next()
        elif key==ord('K')-64:           # ^K: insert ^C
            self.insert(chr(3))
        elif (key>=ord(' ') and key<256) or key in [1,2,3,22,31]:
            self.insert(chr(key))

    def handle_key_input(self,key):
        if key==curses.KEY_LEFT:
            self.left()
        elif key==curses.KEY_RIGHT:
            self.right()
        elif key==curses.KEY_HOME:
            self.home()
        elif key==curses.KEY_END:
            self.end()
        elif key==curses.KEY_BACKSPACE:
            self.backspace()
        elif key==ord('K')-64:           # ^K: insert ^C
            self.insert(chr(3))
        elif (key>=ord(' ') and key<256) or key in [1,2,3,22,31]:
            self.insert(chr(key))

    def cursor_pos(self):
        return (self.xpos,0)

    def redraw(self):
        """
        Redraw the widget, eg. as the result of input.
        Used internally.
        """
        global attrmap

#        colour=0x1E
        str=InputWidget.format_re.split(self.text[self.xscroll:self.xscroll+self.wid-1])
        self.pad.move(0,0)
        while 1:
            self.pad.addstr(str[0])
            del str[0]
            if not str:
                break
            self.pad.addch(ord(str[0])+64+attrmap[0xE1])
            del str[0]

#        self.pad.addstr(0,0,self.text[self.xscroll:self.xscroll+self.wid-1])
        self.pad.clrtoeol()
        self.window.pad.move(self.pos.y1(),self.pos.x1()+self.xpos)
        self.fresh()
    
    def left(self):
        if self.xpos==0:
            return
        if self.xpos<=self.wid/3 and self.xscroll>0:
            self.xscroll=self.xscroll-1
        else:
            self.xpos=self.xpos-1
        self.redraw()

    def right(self):
        if self.xscroll+self.xpos>=len(self.text):
            return
        if self.xpos>=self.wid-1-self.wid/3 and self.xscroll+self.wid-1<len(self.text):
            self.xscroll=self.xscroll+1
        else:
            self.xpos=self.xpos+1
        self.redraw()  

    def insert(self,key):
        self.text=self.text[:self.xscroll+self.xpos]+key+self.text[self.xscroll+self.xpos:]
        self.right()

    def backspace(self):
        if self.xpos==0:                 # at start of line?
            return
        self.text=self.text[:self.xscroll+self.xpos-1]+self.text[self.xscroll+self.xpos:]
        self.left()

    def clear(self):
        self.text=''
        self.xpos=self.xscroll=0
        self.redraw()

    def enter(self):
        if len(self.text):               # don't bother remembering empty lines
            self.history.insert(0,self.text)
        self.histindex=-1 
        self.clear()

    def prev(self):
        """ previous entry in history """
#        echo('.status',str(len(self.history))+' '+str(self.histindex))
        if self.histindex==len(self.history)-1: # at beginning of history already?
            return

        # save current line if modified to go here

        self.histindex=self.histindex+1
        self.text=self.history[self.histindex]
        self.end()

    def next(self):
        """ next entry in history """
        if self.histindex==-1: # at end of history already?
            return

        # save current line if modified to go here

        self.histindex=self.histindex-1
        if self.histindex==-1: # at end of history now?
            self.clear()
        else:
            self.text=self.history[self.histindex]
            self.end()

    def home(self):
        self.xpos=self.xscroll=0
        self.redraw()

    def end(self):
        if len(self.text)>=self.wid-1:
            self.xpos=self.wid-1
            self.xscroll=len(self.text)-self.xpos
        else:
            self.xpos=len(self.text)
            self.xscroll=0
        self.redraw()

###############################################################################

###############################################################################

class RootWindow:
    def __init__(self):
        global attrmap
        global stdscr

        self.hgt,self.wid=stdscr.getmaxyx() # not sure if this is required.
        self.pad=curses.newpad(self.hgt,self.wid)
        self.pad.bkgd(attrmap[0x1E]+ord('')) 
        self.pos=BaseRect(self.wid,self.hgt)
        self.windows=[self]              # windows[-1] will always be the root window. [0] is the top window
        self.root=self                   # I *am* the root window.

    def __repr__(self):
        return '<RootWindow %dx%d)>'%(self.wid,self.hgt)

    def update(self,rect=None):           # noutrefresh & update visible portion of rect (rect is relative to window)
        global stdscr # convert to rootwindow?
        windows=self.root.windows

        debugmsg('\nRootWindow.update(): updating %s'%self)
        if not rect:
            debugmsg('   RootWindow.update(): defaulting rect')
            rect=Rect(self.pos,0,0,0,0,0,0,1,1)

        # check to make sure window is visible
        if not self in windows:          # window not visible?
            return                       # nothing to do

        wpos=[rect.gxyxy_clip()]         # convert to screen coords & clip
        if not wpos[0]: 
            debugmsg('!!RootWindow.update(): %s is totally off screen'%rect)
#            return                       # completely off screen

        debugmsg('RootWindow.update(): 1 wpos=%s'%wpos)
        for win in windows[0:windows.index(self)]: # for all windows above rect's window
            wpos=win.pos.mask_out_of(wpos)
        debugmsg('RootWindow.update(): 2 wpos=%s'%wpos)

        debugmsg('RootWindow.update(): %s'%self)
        debugmsg('RootWindow.update(): wpos=%s'%wpos)
        for r in wpos:
            debugmsg('    r=%s'%(r))
            debugmsg('    r.add=%s'%(r.add))
            w=r.add(-self.pos.x1(),-self.pos.y1())       # position of redrawn portion of rect relative to window
            debugmsg('    about to update %s->%s'%(r,w))
            self.pad.noutrefresh(w.y1(),w.x1(),r.y1(),r.x1(),r.y2(),r.x2())
        curses.doupdate()

    def rect(self,pos):
        if len(pos)==4:
            x1,y1,x2,y2=pos
            return Rect(self.pos,x1,y1,x2,y2,0,0,0,0)
        else:
            x1,y1,x2,y2,x1p,y1p,x2p,y2p=pos
            return Rect(self.pos,x1,y1,x2,y2,x1p,y1p,x2p,y2p)

    def updateall(self,rect): # update everything on a particular bit of screen.
    #    global stdscr

        # clip rect to screen to go here? no, window.fresh() does that

        debugmsg('\nupdateall(%s)'%rect)
        for w in self.windows:
            r=rect.add(-w.pos.x1(),-w.pos.y1())
            debugmsg('    About to fresh %s %s bit of %s'%(r,w.pos,w))
            w.update(r)
    #        w.pad.touchwin()
    #        r=rect.unoffset(w.pos).clip(Rect(0,0,w.pos.wid()-1,w.pos.hgt()-1)) # clip to window size
    #        if r:
    #            debugmsg('    About to fresh '+str(r)+str(rect.unoffset(w.pos))+' bit of '+str(w))
    #            w.fresh(r)
    #        else:
    #            debugmsg('    Not freshalling '+str(w)+' because it\'s not near '+str(rect))
    #    stdscr.touchwin()
    #    r=rect.clip(Rect(0,0,rootwindow.wid-1,rootwindow.hgt-1)) # clip to window size
    #    if r:
    #        rootwindow.fresh(r)
        curses.doupdate()

class Window(RootWindow):
    """
    This will hopefully cover all classes of windows
    This might spawn a superclass, especially to handle the root window (20000408: actually, it did)
    """
    def __init__(self,parent,pos,colour=None,border_colour=None):
        """
        pos is relative to the parent's position
        It is an 8-record tuple.
        """
        global attrmap

        self.pos=parent.rect(pos)
        self.parent=parent
        self.root=parent.root            # if the parent *is* the root then parent==root
        self.pad=curses.newpad(self.pos.hgt(),self.pos.wid())
        if not colour:
            colour=0x07
        if not border_colour:
            border_colour=0x0F
#        self.set_bgcol(border_colour)
        self.pad.bkgd(attrmap[border_colour]+255) 
        self.pad.box()
        self.set_bgcol(colour)
        self.pad.nodelay(1)
        self.pad.keypad(1)
        self.taborder=[]                 # focusable widgets, in order
        self.curr_widget=None
        self.is_visible=0

    def __getitem__(self,item):          # this is just a convenience of notation
        return self.widget[item]         #   (ie. somewindow.widget["somewidget"] -> somewindow[somewidget])

    def __repr__(self):
        return '<Window at %s>'%(self.pos)

#    def __del__(self):                   # not sure if this is actually at all useful
#        self.hide()

    def set_bgcol(self,col):
        self.bgcol=col
        self.pad.bkgdset(attrmap[self.bgcol]+255) 

    def show(self):
        if not self.is_visible:
            self.root.windows[0:0]=[self] # insert self at beginning of list
            self.is_visible=1
            self.update()                # redraw all of self

    def hide(self):
        # if visible or either doesn't have a handle_close() or it returns non-zero:
        if self.is_visible and (not hasattr(self,'handle_close') or self.handle_close()):
            self.is_visible=0
            self.root.windows.remove(self)
            freshall(self.rect)

    def handle_key(self,key):
        if self.curr_widget:
            if key==9:
                if self.curr_widget==self.taborder[-1]:
                    self.curr_widget=self.taborder[0]
                else:
                    self.curr_widget=self.taborder[self.taborder.index(self.curr_widget)+1]
            else:
                # curr_widget *should* have a handle_key()
                self.curr_widget.handle_key(key)

    def set_cursor(self):
        if self.curr_widget and hasattr(self.curr_widget,'cursor_pos'):
            x,y=self.curr_widget.cursor_pos() # get cursor position within widget
            x=self.curr_widget.pos.x1()+x # get cursor position within window
            y=self.curr_widget.pos.y1()+y
        else:
            # In the absence of curs_set() I'm just going to move 
            # the cursor to the top-left corner of the window
            x=0
            y=0
        self.pad.move(y,x)
        self.update(Rect(self.pos,x,y,x+1,y+1,0,0,0,0)) # update the char the cursor is on

    def xxxmove(self,pos):
        """ Move and/or resize window to new location pos """
        old_pos=self.pos
        self.pos=pos
        freshall(pos)
        freshall(old_pos)

###############################################################################

def debugmsg(msg):
    global debugfd
    debugfd.write(msg+'\n')
    pass

debugfd=open('/dev/tty8','w+')
if not debugfd:
    print('Debug messages will go to stderr')
    debugfd=System.stderr
else:
    print('Debug messages will go to tty8')
    debugmsg('\n============================================================')

def wm():
    global stdscr
    global rootwindow

    windows=rootwindow.windows

    p=curses.newpad(1,1)
#    p.nodelay(1)
    p.keypad(1)

    curses.doupdate()
#    stdscr.keypad(1)
#    stdscr.nodelay(0)
    while 1:
        debugmsg("wm(): windows=%s"%windows)
        if len(windows)>1:               # more than just the root window?
            top_window=windows[0]
        else:
            top_window=None

        if top_window:
            top_window.set_cursor()
        else:
            raise 'unimplemented','don\'t know where to put cursor'

        if sys.stdin in select.select([sys.stdin],[],[])[0]:
            key=p.getch()
        else:
            raise 'umm','select() returned unexpectedly'

        # sometimes other threads change the top window while we're waiting for a key...
        if len(windows):
            top_window=windows[0]
        else:
            top_window=None

        # global functions
        if key==curses.KEY_F12:          # F12=quit
            return

        # window functions
        if top_window:                   # if there are windows on the screen (and therefore a top window)

            # WARNING! this code does not always leave windows[-1] at the bottom of the stack!

            # should these handlers happen before (as it is now)
            # or after the window's handle_key()?
            if key==curses.KEY_F6:       # F6=Next window
                windows=windows[-1:]+windows[:-1]
                top_window=windows[0]    # probably superfluous.
                freshall(top_window.pos)
            elif key==curses.KEY_F18:    # ShiftF6=Previous window
                windows=windows[1:]+windows[:1]
                top_window=windows[0]    # probably superfluous.
                freshall(windows[-1].pos)
            elif key==curses.KEY_F1:
                top_window.move(top_window.pos.add(Rect(0,-1,0,-1)))
            elif key==curses.KEY_F2:
                top_window.move(top_window.pos.add(Rect(0,1,0,1)))
            elif key==curses.KEY_F3:
                top_window.move(top_window.pos.add(Rect(-1,0,-1,0)))
            elif key==curses.KEY_F4:
                top_window.move(top_window.pos.add(Rect(1,0,1,0)))
            elif key==curses.KEY_F16:    # ShiftF4=Close window
                top_window.hide()
            elif 0 and key==curses.KEY_F17:    # ShiftF5=Move window
                mv_win=top_window
                old_pos=top_window.pos.clone
                new_pos=top_window.pos
                
                while 1:
                    if sys.stdin in select.select([sys.stdin],[],[])[0]:
                        key=p.getch()
                    else:
                        raise 'umm','select() returned unexpectedly'
                    if key==curses.KEY_UP:
                        new_pos=new_pos.add(Rect(0,-1,0,0))
#                        freshall(
#                    if key=='\r':
                        

            else:
                if key>=0:
                    if hasattr(top_window,'handle_key'): # top window has handle_key()
                        top_window.handle_key(key)
                    else:
                        raise 'assert','top_window missing handle_key()'
#                        w['testbuf'].echo('top_window is missing handle_key()'+str(hasattr(top_window,'handle_key')))

        # sekrit testing stuff
#        for w in windows:
        if 0:
            if hasattr(w,'testwindow'):
                if key>=0:
                    w['text'].set(str(key))
                if key==curses.KEY_F15:
                    w['title'].set('It''s time to change the title to something just a little bit longer...                  ')
                elif key==curses.KEY_F10:
                    testapp.ClockApp().start()
                elif key==curses.KEY_F16:
                    for b in range(128,256,16):
                        s=str(b)+' '
                        for c in range(0,16):
                            s=s+chr(b+c)
                        w['testbuf'].echo(s)
                w['title'].set(w['title'].text[1:]+w['title'].text[:1])
                if 1 or w['title'].text[0]=='e':
                    w['testbuf'].echo(w['title'].text[:39])
    #                w['testbuf'].echo('>>>'+w['title'].text)

def xxxfreshall(rect): # refresh all windows
    global windows
#    global stdscr
    global rootwindow

    # clip rect to screen to go here? no, window.fresh() does that

#    debugmsg('\nrefreshall('+str(rect)+')')
    for w in windows:
#        w.pad.touchwin()
        r=rect.unoffset(w.pos).clip(Rect(0,0,w.pos.wid()-1,w.pos.hgt()-1)) # clip to window size
        if r:
#            debugmsg('    About to fresh '+str(r)+str(rect.unoffset(w.pos))+' bit of '+str(w))
            w.fresh(r)
#        else:
#            debugmsg('    Not freshalling '+str(w)+' because it\'s not near '+str(rect))
#    stdscr.touchwin()
    r=rect.clip(Rect(0,0,rootwindow.wid-1,rootwindow.hgt-1)) # clip to window size
    if r:
        rootwindow.fresh(r)
#    curses.doupdate()

###############################################################################

def _init():
    global stdscr
    global attrmap
    global rootwindow

    curses.noecho()
    curses.cbreak()
    curses.nonl()

    # first, let's do some sanity checks on the ncurses Python module.

    if not 'bkgd' in dir(stdscr):        # really crap cursesmodule
        debugmsg('Ack! No bkgd() function - update your Python ncurses module!')
        sys.exit(1)

    if curses.__dict__.has_key('key_f1'):
        # define NCURSES_VERSION "1.9.9g"
        # colours might also be swapped...

        debugmsg('Ack! Your Python curses module contains lower case KEY_* constants (keyname()\'s fault)!')
        sys.exit(1)

    # mermaid : curses.h.in,v 1.36 1996/11/16 21:55:54 tom 
    # mussel : curses.h.in,v 1.60 1998/02/11 12:13:46 tom 

#    if curses.__dict__.has_key('has_colors') and curses.has_colors():
    if curses.__dict__.has_key('has_colors') and curses.has_colors():
        curses.start_color()

        # init 64 colour pairs
        colour=[curses.COLOR_BLACK,curses.COLOR_BLUE,curses.COLOR_GREEN,curses.COLOR_CYAN,
                curses.COLOR_RED,curses.COLOR_MAGENTA,curses.COLOR_YELLOW,curses.COLOR_WHITE]
        for index in range(1,64):
            # The ordering of colours means that index 0 has the colour we
            # wanted to, because we can't change it.
            curses.init_pair(index,colour[index&7^7],colour[index/8])

        def funkify(index):
            """ map (colour) index 0..255 to curses Attribute """
            return curses.A_ALTCHARSET*0+(index&128!=0)*curses.A_BLINK+ \
                   (index&8!=0)*curses.A_BOLD+    \
                   curses.COLOR_PAIR((index&112)/2+(index&7^7))
    else:
        def funkify(index):
            """ map (colour) index 0..255 to curses Attribute """
            # This may need a bit of tweaking.
            # I may even decide to return a constant. Thought then again that wouldn't be
            # very good as then non-text bits (widgets, etc) would never be bold/dim/tc
            return (index&128!=0)*curses.A_CHARTEXT*0+ \
                   (index&8!=0)*curses.A_BOLD

    # map fg/bg colour combinations to attributes (tricky on mono terminals! :)
    attrmap=map(funkify,range(0,256))
    rootwindow=RootWindow() # XXX update RootWindow to reflect new BaseRect

#    rootwindow.fresh(BaseRect(rootwindow.wid,rootwindow.hgt)) 
    rootwindow.update() 

    #stdscr.keypad(1)
#    stdscr.bkgd(attrmap[0x1E]+ord('')) # this may one day just become a special window...
#    stdscr.refresh()
#    curses.doupdate()

def init(main):
    """
    The main program has to be inside this exception block in order to ensure
    curses.endwin() happens. sys.exitfunc doesn't get called early enough (it
    happens *after* an exception dump is printed, which is no good if we want
    to be able to read it :)
    """
    global stdscr

    print("Initialising curses")
    stdscr=curses.initscr()

    try:
        _init()
        main()
    finally:
        curses.endwin()
#        print("[H\ncurses deinit'd")
        print("\ncurses deinit'd")

###############################################################################

def wibble():
    class TestBufferWidget(BufferWidget):
        def frob(self,text):
            self.echo(str(self.window.pos)+' '+text)

    class TestListWidget(ListWidget):
        def handle_update(self):
            pass

    win=Window(Rect(15,5,60,25))
    b1=TestBufferWidget(win,Rect(2,5,43,18))
    title=TextWidget(win,Rect(1,1,42,1))
    TextWidget(win,Rect(1,3,42,3))
    b1.echo("Hello, world!")
    title.set("This is the title ")
    win.show()
    win.testwindow=None              # sekrit indicator to wm()

    w2=Window(Rect(45,3,70,15))
    w2.set_bgcol(0x9F)
    list=TestListWidget(w2,Rect(1,1,24,11),[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20])
    w2.show()

    w3=Window(Rect(30,15,95,35))
    b2=TestBufferWidget(w3,Rect(1,1,64,11))
    InputWidget(w3,Rect(1,12,64,12),b1.frob) 
    InputWidget(w3,Rect(1,13,64,13),b2.frob)
    w3.show()

if __name__=="__main__":
    def test1():
        global attrmap

        w=curses.newwin(0,0,0,0)
        for bg in range(0,16):
            for fg in range(0,16):
                w.addstr("Hello ",attrmap[bg*16+fg])
            w.addstr("\n")
            for fg in range(0,16):
                w.addstr("World ",attrmap[bg*16+fg])
            w.addstr("\n")
            w.refresh()

        w.getch()

    def test2():
#        curses.doupdate()
        wibble()
        
        wm()

    def test3():
        win=ChannelWindow('#test',Rect(15,5,75,23))
        win['testbuf'].echo("Hello, world!")
#        win['title'].set("Title")
#        win.redraw()

        win.pad.getch()

    init(test2)
